#!/usr/bin/perl
# Author: Mike Brodbelt
# Date: 27/07/2006

# This is an ugly hack necessitated by the fact that several devices around have 64 bit
# counters, but will only offer SNMP v1, which is limited to 32 bit return values from OID
# queries. We use Bit::Vector to deal with integers that won't fit in 32 bits.

use Bit::Vector;

my $snmpget = "/usr/local/bin/snmpget";

my $oidlist = ".1.3.6.1.4.1.7146.1.2.1.5.0 " .		# ZXTM-MIB::totalBytesInLo.0
	      ".1.3.6.1.4.1.7146.1.2.1.6.0 " .		# ZXTM-MIB::totalBytesInHi.0
	      ".1.3.6.1.4.1.7146.1.2.1.7.0 " .		# ZXTM-MIB::totalBytesOutLo.0
	      ".1.3.6.1.4.1.7146.1.2.1.8.0";		# ZXTM-MIB::totalBytesOutHi.0

my ($community, $address) = @ARGV;
my $totalbytesin = 0;
my $totalbytesout = 0;

# Use 33 bit vectors for the high 32 bits - they get initialised to zero, and if we use 
# 32 bit vectors then the decimal conversion goes wrong, as it assumes we're a signed
# two's complement format.

if (($community ne '') && ($address ne '')) {
	open(PROCESS, "$snmpget -OEqs -v 1 -c $community $address $oidlist | ");
	foreach (<PROCESS>) {
		chomp;
		/^totalBytesInLo.0 (\d+)$/ && do { $totalbytesinlo = Bit::Vector->new_Dec(32, $1); next };
		/^totalBytesInHi.0 (\d+)$/ && do { $totalbytesinhi = Bit::Vector->new_Dec(33, $1); next };
		/^totalBytesOutLo.0 (\d+)$/ && do { $totalbytesoutlo = Bit::Vector->new_Dec(32, $1); next };
		/^totalBytesOutHi.0 (\d+)$/ && do { $totalbytesouthi = Bit::Vector->new_Dec(33, $1); next };
	}
	close(PROCESS);

	$totalbytesin = $totalbytesinhi->Concat($totalbytesinlo);
	$totalbytesout = $totalbytesouthi->Concat($totalbytesoutlo);

	print "totalBytesIn:" . $totalbytesin->to_Dec() . " " . "totalBytesOut:" . $totalbytesout->to_Dec() . "\n";
} else {
	print "Usage: $0 <community> <ip_address>\n";
}
